﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class MainForm
    Private Sub ActHelpAbout_Click(sender As Object, e As EventArgs) Handles ActHelpAbout.Click
        ' ----- Show the About form.
        AboutProgram.ShowDialog()
    End Sub

    Private Sub ActLibraryItem_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActLibraryItem.LinkClicked
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub PicLibraryItem_Click(sender As Object, e As EventArgs) Handles PicLibraryItem.Click
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub ActPatronRecord_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActPatronRecord.LinkClicked
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub PicPatronRecord_Click(sender As Object, e As EventArgs) Handles PicPatronRecord.Click
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub ActHelp_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActHelp.LinkClicked
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub PicHelp_Click(sender As Object, e As EventArgs) Handles PicHelp.Click
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub ActCheckOut_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckOut.LinkClicked
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub PicCheckOut_Click(sender As Object, e As EventArgs) Handles PicCheckOut.Click
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub ActCheckIn_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckIn.LinkClicked
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub PicCheckIn_Click(sender As Object, e As EventArgs) Handles PicCheckIn.Click
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub ActAdmin_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActAdmin.LinkClicked
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub PicAdmin_Click(sender As Object, e As EventArgs) Handles PicAdmin.Click
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub ActProcess_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActProcess.LinkClicked
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub PicProcess_Click(sender As Object, e As EventArgs) Handles PicProcess.Click
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub ActReports_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActReports.LinkClicked
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub PicReports_Click(sender As Object, e As EventArgs) Handles PicReports.Click
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub TaskLibraryItem()
        ' ----- Library item task.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelLibraryItem.Visible = True
        ActLibraryItem.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicLibraryItem.Top)
        Me.AcceptButton = ActSearch

        ' ----- Get ready for a new search.
        If (SearchText.CanFocus) Then SearchText.Focus()
    End Sub

    Private Sub TaskPatronRecord()
        ' ----- Patron Record mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelPatronRecord.Visible = True
        ActPatronRecord.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicPatronRecord.Top)
        Me.AcceptButton = ActAccessPatron
    End Sub

    Private Sub TaskHelp()
        ' ----- Help mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelHelp.Visible = True
        ActHelp.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicHelp.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskCheckOut()
        ' ----- Check Out mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.CheckOutItems)) Then _
            PanelCheckOut.Visible = True
        ActCheckOut.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckOut.Top)
        Me.AcceptButton = ActDoCheckOut
    End Sub

    Private Sub TaskCheckIn()
        ' ----- Check In mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.CheckInItems)) Then _
            PanelCheckIn.Visible = True
        ActCheckIn.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckIn.Top)
        Me.AcceptButton = ActDoCheckIn

        ' ----- Reset the input fields.
        CheckInDate.Value = Today
        CheckInDate.MaxDate = Today
        CheckInDate.MinDate = Today.AddDays(-6)
        CheckInDay.Text = "Today"
        CheckInDay.BackColor = SystemColors.Control
        CheckInDay.ForeColor = SystemColors.ControlText
        CheckInBarcode.Text = ""
        LabelCheckedIn.Visible = False
        CheckedInDetail.Visible = False
        CheckedInDetail.Text = "No information available."
        CheckInBarcode.Focus()
    End Sub

    Private Sub TaskAdmin()
        ' ----- Administration mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        If (SecurityProfile(LibrarySecurity.AdminFeatures)) Then _
            PanelAdmin.Visible = True

        ActAdmin.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicAdmin.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskProcess()
        ' ----- Daily Processing mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.DailyProcessing)) Then _
            PanelProcess.Visible = True
        ActProcess.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicProcess.Top)
        Me.AcceptButton = ActDoProcess
    End Sub

    Private Sub TaskReports()
        ' ----- Print Reports mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.RunReports)) Then _
            PanelReports.Visible = True
        ActReports.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicReports.Top)
        Me.AcceptButton = ActDoReports
    End Sub

    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Adjust the various panel positions.
        PanelLibraryItem.Location = New Point(
            TaskListBackground.Width, WelcomeBackground.Height)
        PanelPatronRecord.Location = PanelLibraryItem.Location
        PanelHelp.Location = PanelLibraryItem.Location
        PanelCheckOut.Location = PanelLibraryItem.Location
        PanelCheckIn.Location = PanelLibraryItem.Location
        PanelAdmin.Location = PanelLibraryItem.Location
        PanelProcess.Location = PanelLibraryItem.Location
        PanelReports.Location = PanelLibraryItem.Location
        PanelLibraryItem.Visible = True
        ActSearchLimits.PerformClick()

        ' ----- Prepare for a patron user.
        UpdateDisplayForUser()
    End Sub

    Private Sub AllPanelsInvisible()
        ' ----- Hide all work panels.
        PanelLibraryItem.Visible = False
        PanelPatronRecord.Visible = False
        PanelHelp.Visible = False
        PanelCheckOut.Visible = False
        PanelCheckIn.Visible = False
        PanelAdmin.Visible = False
        PanelProcess.Visible = False
        PanelReports.Visible = False

        ' ----- Correctly color all action labels.
        ActLibraryItem.BackColor = Color.White
        ActPatronRecord.BackColor = Color.White
        ActHelp.BackColor = Color.White
        ActCheckOut.BackColor = Color.White
        ActCheckIn.BackColor = Color.White
        ActAdmin.BackColor = Color.White
        ActProcess.BackColor = Color.White
        ActReports.BackColor = Color.White
    End Sub

    Private Sub SearchText_Enter(sender As Object, e As EventArgs) Handles SearchText.Enter
        ' ----- Highlight the entire text.
        SearchText.SelectAll()
    End Sub

    Private Sub ActSearchLimits_Click(sender As Object, e As EventArgs) Handles ActSearchLimits.Click
        ' ----- Toggle the display of the media type and location fields.
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then
            ' ----- Hide the two fields.
            LabelSearchMediaType.Visible = False
            SearchMediaType.Visible = False
            LabelSearchLocation.Visible = False
            SearchLocation.Visible = False
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                SearchMediaType.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                SearchMediaType.Top)
            ActSearch.Location = New Point(ActSearch.Left, SearchMediaType.Top)
            ActSearchLimits.Text = "Mor&e >>"
        Else
            ' ----- Show the two fields.
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                LabelMoreLimitsTop.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                LabelMoreLimitsTop.Top)
            ActSearch.Location = New Point(ActSearch.Left, LabelMoreLimitsTop.Top)
            LabelSearchMediaType.Visible = True
            SearchMediaType.Visible = True
            LabelSearchLocation.Visible = True
            SearchLocation.Visible = True
            ActSearchLimits.Text = "<< L&ess"
        End If
    End Sub

    Private Sub CheckInBarcode_Enter(sender As Object, e As EventArgs) Handles CheckInBarcode.Enter
        ' ----- Highlight the entire text.
        CheckInBarcode.SelectAll()
    End Sub

    Private Sub CheckOutBarcode_Enter(sender As Object, e As EventArgs) Handles CheckOutBarcode.Enter
        ' ----- Highlight the entire text.
        CheckOutBarcode.SelectAll()
    End Sub

    Private Sub MainForm_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        ' ----- The keys F2 through F9 access the different sections of the form.
        Select Case (e.KeyCode)
            Case Keys.F2
                TaskLibraryItem()
                e.Handled = True
            Case Keys.F3
                TaskPatronRecord()
                e.Handled = True
            Case Keys.F4
                ' ----- Allow form to handle Alt+F4.
                If (e.Alt = True) Then
                    Me.Close()
                Else
                    TaskHelp()
                End If
                e.Handled = True
            Case Keys.F5
                TaskCheckOut()
                e.Handled = True
            Case Keys.F6
                TaskCheckIn()
                e.Handled = True
            Case Keys.F7
                TaskAdmin()
                e.Handled = True
            Case Keys.F8
                TaskProcess()
                e.Handled = True
            Case Keys.F9
                TaskReports()
                e.Handled = True
            Case Keys.F12
                ' ----- Prompt the user for patron or administrative mode.
                ShowLoginForm()
                e.Handled = True
        End Select
    End Sub

    Private Sub AdminLinkGroups_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkGroups.LinkClicked
        ' ----- Let the user edit the list of security groups.
        If (SecurityProfile(LibrarySecurity.ManageGroups) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New GroupName)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkUsers_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkUsers.LinkClicked
        ' ----- Let the user edit the list of administrative users.
        If (SecurityProfile(LibrarySecurity.ManageUsers) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New UserName)
        ListEditRecords = Nothing
    End Sub

    Private Sub ActLogin_Click(sender As Object, e As EventArgs) Handles ActLogin.Click
        ' ----- Prompt the user for patron or administrative mode.
        ShowLoginForm()
    End Sub

    Private Sub ShowLoginForm()
        ' ----- Prompt the user for patron or administrative mode.
        Dim userChoice As DialogResult

        userChoice = ChangeUser.ShowDialog()
        ChangeUser = Nothing
        If (userChoice = DialogResult.OK) Then UpdateDisplayForUser()
    End Sub

    Private Sub UpdateDisplayForUser()
        ' ----- Update the display based on the user settings.
        Dim sqlText As String
        Dim sqlRun As DataCommand

        If (LoggedInUserID = -1&) Then
            ' ----- Set up the display for patron mode.
            ActiveMode.Text = "Welcome Library Patron"
            LabelTasks.Visible = False
            LineTasks.Visible = False
            PicCheckOut.Visible = False
            ActCheckOut.Visible = False
            PicCheckIn.Visible = False
            ActCheckIn.Visible = False
            PicAdmin.Visible = False
            ActAdmin.Visible = False
            PicProcess.Visible = False
            ActProcess.Visible = False
            PicReports.Visible = False
            ActReports.Visible = False
            ActLogin.Visible = True

            ' ----- Lookup items by default.
            TaskLibraryItem()
        Else
            ' ----- Set up the display for administrative mode.
            sqlText = "SELECT FullName FROM UserName WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", LoggedInUserID)
            Try
                ActiveMode.Text = "Administrative User: " & DBGetText(ExecuteSQLReturn(sqlRun))
            Catch ex As Exception
                GeneralError("MainForm.UpdateDisplayForUser", ex)
                ActiveMode.Text = "Administrative User: Unknown"
            End Try

            LabelTasks.Visible = True
            LineTasks.Visible = True
            PicCheckOut.Visible = True
            ActCheckOut.Visible = True
            PicCheckIn.Visible = True
            ActCheckIn.Visible = True
            PicAdmin.Visible = True
            ActAdmin.Visible = True
            PicProcess.Visible = True
            ActProcess.Visible = True
            PicReports.Visible = True
            ActReports.Visible = True
            ActLogin.Visible = True
        End If
    End Sub

    Private Sub AdminLinkItems_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkItems.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageItems) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of items.
        ListEditRecords.ManageRecords(New NamedItem)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthors_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthors.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthors) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of authors.
        ListEditRecords.ManageRecords(New Author)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthorTypes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthorTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthorTypes) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of author types.
        ListEditRecords.ManageRecords(New CodeAuthorType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPublishers_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPublishers.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePublishers) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of publishers.
        ListEditRecords.ManageRecords(New Publisher)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkSeries_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkSeries.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageSeries) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of series.
        ListEditRecords.ManageRecords(New CodeSeries)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkMediaTypes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkMediaTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageMediaTypes) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of media types.
        ListEditRecords.ManageRecords(New CodeMediaType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkStatusCodes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkStatusCodes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageCopyStatus) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of copy status codes.
        ListEditRecords.ManageRecords(New CodeCopyStatus)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkLocations_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkLocations.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageLocations) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of locations.
        ListEditRecords.ManageRecords(New CodeLocation)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkHolidays_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkHolidays.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageHolidays) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of holidays.
        ListEditRecords.ManageRecords(New Holiday)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPatrons_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPatrons.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatrons) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of patrons.
        ListEditRecords.ManageRecords(New Patron)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPatronGroups_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPatronGroups.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatronGroups) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of patron groups.
        ListEditRecords.ManageRecords(New CodePatronGroup)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkValues_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkValues.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageValues) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of system values.
        ListEditRecords.ManageRecords(New Library.SystemValue)
        ListEditRecords = Nothing
    End Sub
End Class
