﻿Public Class Form1
    Private WithEvents HelloDecoder As HelloStuff.SayHello

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        ' ----- Create an instance of a hello decoder and
        '       have it show the message.
        HelloDecoder = New HelloStuff.SayHello("!iqwtB ,tqqjM", True)
        HelloDecoder.DecodeMessage(-5)
        HelloDecoder.ReportMessage()
    End Sub

    Private Sub HelloDecoder_MessageDecoded(decodedMessage As String) Handles HelloDecoder.MessageDecoded
        ' ----- Show the decoded message.
        MessageBox.Show(decodedMessage)
    End Sub
End Class

Namespace HelloStuff
    Friend Class SayHello
        Private secretMessage As String
        Private reverseFlag As Boolean
        Private decoded As Boolean

        Public Event MessageDecoded(decodedMessage As String)

        Public Sub New(codedMessage As String, reverseIt As Boolean)
            ' ----- Save the secret message. It will be decoded later.
            secretMessage = codedMessage
            reverseFlag = reverseIt
            decoded = False
        End Sub

        Public Sub DecodeMessage(rotationFactor As Integer)
            ' ----- The original message was coded, Rotate each character
            '       through the alphabet by the specified number of times
            '       to get the true value.
            Dim result As String
            Dim oneChar As Char
            Dim charValue As Integer

            ' ----- Don't decode twice.
            If (decoded = True) Then Return

            ' ----- Process each character.
            result = ""
            For counter As Integer = 0 To secretMessage.Length - 1
                oneChar = CChar(secretMessage.Substring(counter, 1))
                If (Char.IsLower(oneChar) = True) Then
                    ' ----- Rotate the character. Convert it to an integer,
                    '       rotate it, then convert it back.
                    charValue = Asc(oneChar) - Asc("a"c)
                    charValue = (charValue + rotationFactor + 26) Mod 26
                    oneChar = Chr(charValue + Asc("a"c))
                    result &= oneChar
                ElseIf (Char.IsUpper(oneChar) = True) Then
                    ' ----- Rotate the character. Convert it to an integer,
                    '       rotate it, then convert it back.
                    charValue = Asc(oneChar) - Asc("A"c)
                    charValue = (charValue + rotationFactor + 26) Mod 26
                    oneChar = Chr(charValue + Asc("A"c))
                    result &= oneChar
                Else
                    ' ----- No special translation on this character.
                    result &= oneChar
                End If
            Next counter

            ' ----- Store the converted value.
            secretMessage = result
            decoded = True
        End Sub

        Public Sub ReportMessage()
            ' ----- Fire an event for the caller.
            If (reverseFlag = True) Then
                RaiseEvent MessageDecoded(StrReverse(secretMessage))
            Else
                RaiseEvent MessageDecoded(secretMessage)
            End If
        End Sub
    End Class
End Namespace
