﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class KeywordAdd
    Private ActiveID As Long

    Public Function AddRecord() As Long
        ' ----- Add a new keyword.
        ActiveID = -1&
        Me.ShowDialog()
        If (Me.DialogResult = DialogResult.OK) Then _
            Return ActiveID Else Return -1&
    End Function

    Private Function SaveFormData() As Boolean
        ' ----- Save the record to the database.
        Dim sqlText As String
        Dim newID As Long
        Dim dbInfo As DataTable
        Dim sqlRun As DataCommand

        Me.Cursor = Cursors.WaitCursor

        ' ----- See if this keyword already exists.
        sqlText = "SELECT ID FROM Keyword WHERE FullName = @TestName"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddText("TestName", RecordKeyword.Text.Trim().ToLower())
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("KeywordAdd.SaveFormData.Check", ex)
            Return False
        End Try
        If (dbInfo.Rows.Count > 0) Then ActiveID = DBGetLong(dbInfo.Rows(0) !ID)
        dbInfo.Dispose()
        dbInfo = Nothing

        ' ----- Create a new record if needed.
        If (ActiveID = -1&) Then
            ' ----- Create a new entry.
            sqlText = "INSERT INTO Keyword (FullName) " &
                "OUTPUT INSERTED.ID VALUES (@NewName)"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddText("NewName", RecordKeyword.Text.Trim().ToLower())
            Try
                newID = DBGetLong(ExecuteSQLReturn(sqlRun))
            Catch ex As Exception
                Me.Cursor = Cursors.Default
                GeneralError("KeywordAdd.SaveFormData.Add", ex)
                Return False
            End Try
            ActiveID = newID
        End If

        ' ----- Success.
        Me.Cursor = Cursors.Default
        Return True
    End Function

    Private Function ValidateFormData() As Boolean
        ' ----- Keyword is a required field.
        If (RecordKeyword.Text.Trim().Length = 0) Then
            MessageBox.Show("Please supply a keyword.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            RecordKeyword.Focus()
            Return False
        End If

        ' ----- Success.
        Return True
    End Function

    Private Sub RecordKeyword_Enter(sender As Object, e As EventArgs) Handles RecordKeyword.Enter
        ' ----- Highlight the entire text.
        RecordKeyword.SelectAll()
    End Sub

    Private Sub ActOK_Click(sender As Object, e As EventArgs) Handles ActOK.Click
        ' ----- The user wants to save changes.
        If (ValidateFormData() = False) Then Return
        If (SaveFormData() = False) Then Return

        ' ----- Continue with AddRecord()
        Me.DialogResult = DialogResult.OK
    End Sub

    Private Sub KeywordAdd_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        ' ----- F1 shows online help.
        If (e.KeyCode = Keys.F1) Then OnlineHelp(Me, "KeywordAdd.htm")
    End Sub
End Class