﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class AuthorLimit
    Public Function PromptUser() As String
        ' ----- Prompt the user for search criteria.
        Me.ShowDialog()
        If (Me.DialogResult = DialogResult.OK) Then
            If (OptionAll.Checked = True) Then
                Return "*"
            Else
                Return AuthorName.Text.Trim()
            End If
        Else
            Return ""
        End If
    End Function

    Private Sub AuthorName_Enter(sender As Object, e As EventArgs) Handles AuthorName.Enter
        ' ----- Highlight the entire text.
        AuthorName.SelectAll()
    End Sub

    Private Sub AuthorName_TextChanged(sender As Object, e As EventArgs) Handles AuthorName.TextChanged
        ' ----- Make this a limited search.
        OptionByName.Checked = CBool(AuthorName.Text.Trim().Length <> 0)
        OptionAll.Checked = Not OptionByName.Checked
    End Sub

    Private Sub ActOK_Click(sender As Object, e As EventArgs) Handles ActOK.Click
        ' ----- For name searches, require a value.
        If (OptionByName.Checked = True) And (AuthorName.Text.Trim().Length = 0) Then
            MessageBox.Show("When searching by name, please supply a search text.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If
        Me.DialogResult = DialogResult.OK
    End Sub

    Private Sub AuthorLimit_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        ' ----- F1 shows online help.
        If (e.KeyCode = Keys.F1) Then OnlineHelp(Me, "AuthorLimit.htm")
    End Sub
End Class