﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class ReportBuiltinViewer
    Private StoreDataTable As Object

    Public Sub StartReport(whichReport As String, whichDataSchema As String,
            whichData As Object)
        ' ----- Run one of the built-in reports. whichReport is the name of
        '       the RDLC report file, in the format "Library.xxx.rdlc."
        '       whichDataSchema provides the name of the schema to use,
        '       in the format "Library_xxx." whichDataSet is the actual
        '       data to link to the report, which must match the schema.
        Dim customDataSource As New Microsoft.Reporting.WinForms.ReportDataSource

        ' ----- Connect the viewer, the report, and the data.
        ReportContent.LocalReport.ReportEmbeddedResource = whichReport
        customDataSource.Name = whichDataSchema
        customDataSource.Value = whichData
        ReportContent.LocalReport.DataSources.Add(customDataSource)

        ' ----- Display the report.
        StoreDataTable = whichData
        Me.Show()
    End Sub

    Private Sub ReportBuiltinViewer_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        ' ----- Get rid of the data.
        If (TypeOf StoreDataTable Is IDisposable) Then
            CType(StoreDataTable, IDisposable).Dispose()
        End If
    End Sub

    Private Sub ReportBuiltinViewer_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        ' ----- F1 shows online help.
        If (e.KeyCode = Keys.F1) Then OnlineHelp(Me, "ReportSelect.htm")
    End Sub

    Private Sub ReportBuiltinViewer_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Generate and display the report.
        ReportContent.SetDisplayMode(Microsoft.Reporting.WinForms.DisplayMode.PrintLayout)
        ReportContent.ZoomMode = Microsoft.Reporting.WinForms.ZoomMode.Percent
        ReportContent.ZoomPercent = 100
        ReportContent.RefreshReport()
    End Sub
End Class