﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class MainForm
    Private ActiveCheckOutPatron As Long = -1&

    Private Const StatusImageBad As Integer = 0
    Private Const StatusImageGood As Integer = 1

    Private Sub ActHelpAbout_Click(sender As Object, e As EventArgs) Handles ActHelpAbout.Click
        ' ----- Show the About form.
        AboutProgram.ShowDialog()
    End Sub

    Private Sub ActLibraryItem_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActLibraryItem.LinkClicked
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub PicLibraryItem_Click(sender As Object, e As EventArgs) Handles PicLibraryItem.Click
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub ActPatronRecord_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActPatronRecord.LinkClicked
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub PicPatronRecord_Click(sender As Object, e As EventArgs) Handles PicPatronRecord.Click
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub ActHelp_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActHelp.LinkClicked
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub PicHelp_Click(sender As Object, e As EventArgs) Handles PicHelp.Click
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub ActCheckOut_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckOut.LinkClicked
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub PicCheckOut_Click(sender As Object, e As EventArgs) Handles PicCheckOut.Click
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub ActCheckIn_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckIn.LinkClicked
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub PicCheckIn_Click(sender As Object, e As EventArgs) Handles PicCheckIn.Click
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub ActAdmin_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActAdmin.LinkClicked
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub PicAdmin_Click(sender As Object, e As EventArgs) Handles PicAdmin.Click
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub ActProcess_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActProcess.LinkClicked
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub PicProcess_Click(sender As Object, e As EventArgs) Handles PicProcess.Click
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub ActReports_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActReports.LinkClicked
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub PicReports_Click(sender As Object, e As EventArgs) Handles PicReports.Click
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub TaskLibraryItem()
        ' ----- Library item task.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelLibraryItem.Visible = True
        ActLibraryItem.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicLibraryItem.Top)
        Me.AcceptButton = ActSearch

        ' ----- Get ready for a new search.
        ActSearchClear.PerformClick()
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then _
            ActSearchLimits.PerformClick()
        If (SearchText.CanFocus) Then SearchText.Focus()
    End Sub

    Private Sub TaskPatronRecord()
        ' ----- Patron Record mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelPatronRecord.Visible = True
        ActPatronRecord.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicPatronRecord.Top)
        Me.AcceptButton = ActAccessPatron
    End Sub

    Private Sub TaskHelp()
        ' ----- Help mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelHelp.Visible = True
        ActHelp.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicHelp.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskCheckOut()
        ' ----- Check Out mode.
        Dim userCanCheckOut As Boolean

        ' ----- See if patrons can check out items by themselves.
        userCanCheckOut = CBool(Val(GetSystemValue("PatronCheckOut")))

        ' ----- Update the display.
        AllPanelsInvisible()
        If (userCanCheckOut Or
            SecurityProfile(LibrarySecurity.CheckOutItems)) Then _
            PanelCheckOut.Visible = True
        ActCheckOut.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckOut.Top)
        Me.AcceptButton = ActDoCheckOut
    End Sub

    Private Sub TaskCheckIn()
        ' ----- Check In mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.CheckInItems)) Then _
            PanelCheckIn.Visible = True
        ActCheckIn.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckIn.Top)
        Me.AcceptButton = ActDoCheckIn

        ' ----- Reset the input fields.
        CheckInDate.Value = Today
        CheckInDate.MaxDate = Today
        CheckInDate.MinDate = Today.AddDays(-6)
        CheckInDay.Text = "Today"
        CheckInDay.BackColor = SystemColors.Control
        CheckInDay.ForeColor = SystemColors.ControlText
        CheckInBarcode.Text = ""
        LabelCheckedIn.Visible = False
        CheckedInDetail.Visible = False
        CheckedInDetail.Text = "No information available."
        CheckInBarcode.Focus()
    End Sub

    Private Sub TaskAdmin()
        ' ----- Administration mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        If (SecurityProfile(LibrarySecurity.AdminFeatures)) Then _
            PanelAdmin.Visible = True

        ActAdmin.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicAdmin.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskProcess()
        ' ----- Daily Processing mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.DailyProcessing)) Then _
            PanelProcess.Visible = True
        ActProcess.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicProcess.Top)
        Me.AcceptButton = ActDoProcess
    End Sub

    Private Sub TaskReports()
        ' ----- Print Reports mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.RunReports)) Then _
            PanelReports.Visible = True
        ActReports.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicReports.Top)
        Me.AcceptButton = ActDoReports
    End Sub

    Private Sub MainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        ' ----- Finish the in-process check-out if needed.
        If (ActiveCheckOutPatron <> -1&) Then ActFinishCheckOut.PerformClick()
    End Sub

    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.
        Dim sqlText As String
        Dim dbInfo As DataTable

        ' ----- Adjust the various panel positions.
        PanelLibraryItem.Location = New Point(
            TaskListBackground.Width, WelcomeBackground.Height)
        PanelPatronRecord.Location = PanelLibraryItem.Location
        PanelHelp.Location = PanelLibraryItem.Location
        PanelCheckOut.Location = PanelLibraryItem.Location
        PanelCheckIn.Location = PanelLibraryItem.Location
        PanelAdmin.Location = PanelLibraryItem.Location
        PanelProcess.Location = PanelLibraryItem.Location
        PanelReports.Location = PanelLibraryItem.Location
        PanelLibraryItem.Visible = True
        ActSearchLimits.PerformClick()

        ' ----- Load in the list of search types.
        SearchType.Items.Add(New ListItemData("Lookup By Title", LookupMethods.ByTitle))
        SearchType.SelectedIndex = 0
        SearchType.Items.Add(New ListItemData("Lookup By Author",
            LookupMethods.ByAuthor))
        SearchType.Items.Add(New ListItemData("Lookup By Subject",
            LookupMethods.BySubject))
        SearchType.Items.Add(New ListItemData("Lookup By Keyword (Match Any)",
            LookupMethods.ByKeywordAny))
        SearchType.Items.Add(New ListItemData("Lookup By Keyword (Match All)",
            LookupMethods.ByKeywordAll))
        SearchType.Items.Add(New ListItemData("Lookup By Publisher",
            LookupMethods.ByPublisher))
        SearchType.Items.Add(New ListItemData("Lookup By Series Name",
            LookupMethods.BySeries))
        SearchType.Items.Add(New ListItemData("Lookup By Barcode",
            LookupMethods.ByBarcode))

        ' ----- Load in the media types.
        SearchMediaType.Items.Add(New ListItemData("<All Media Types>", -1&))
        SearchMediaType.SelectedIndex = 0
        sqlText = "SELECT ID, FullName FROM CodeMediaType ORDER BY FullName"
        Try
            dbInfo = CreateDataTable(sqlText)
        Catch ex As Exception
            GeneralError("MainForm.MainForm_Load.Media", ex)
            dbInfo = Nothing
        End Try
        If (dbInfo IsNot Nothing) Then
            For Each dbRow As DataRow In dbInfo.Rows
                SearchMediaType.Items.Add(New ListItemData(
                    DBGetText(dbRow!FullName), DBGetLong(dbRow!ID)))
            Next dbRow
            dbInfo.Dispose()
        End If

        ' ----- Load in the locations.
        SearchLocation.Items.Add(New ListItemData("<All Locations>", -1&))
        SearchLocation.SelectedIndex = 0
        sqlText = "SELECT ID, FullName FROM CodeLocation ORDER BY FullName"
        Try
            dbInfo = CreateDataTable(sqlText)
        Catch ex As Exception
            GeneralError("MainForm.MainForm_Load.Media", ex)
            dbInfo = Nothing
        End Try
        If (dbInfo IsNot Nothing) Then
            For Each dbRow As DataRow In dbInfo.Rows
                SearchLocation.Items.Add(New ListItemData(
                    DBGetText(dbRow!FullName), DBGetLong(dbRow!ID)))
            Next dbRow
            dbInfo.Dispose()
        End If

        ' ----- Prepare for a patron user.
        UpdateDisplayForUser()
    End Sub

    Private Sub AllPanelsInvisible()
        ' ----- Finish the in-process check-out if needed.
        If (ActiveCheckOutPatron <> -1&) Then ActFinishCheckOut.PerformClick()

        ' ----- Hide all work panels.
        PanelLibraryItem.Visible = False
        PanelPatronRecord.Visible = False
        PanelHelp.Visible = False
        PanelCheckOut.Visible = False
        PanelCheckIn.Visible = False
        PanelAdmin.Visible = False
        PanelProcess.Visible = False
        PanelReports.Visible = False

        ' ----- Correctly color all action labels.
        ActLibraryItem.BackColor = Color.White
        ActPatronRecord.BackColor = Color.White
        ActHelp.BackColor = Color.White
        ActCheckOut.BackColor = Color.White
        ActCheckIn.BackColor = Color.White
        ActAdmin.BackColor = Color.White
        ActProcess.BackColor = Color.White
        ActReports.BackColor = Color.White
    End Sub

    Private Sub SearchText_Enter(sender As Object, e As EventArgs) Handles SearchText.Enter
        ' ----- Highlight the entire text.
        SearchText.SelectAll()
    End Sub

    Private Sub ActSearchLimits_Click(sender As Object, e As EventArgs) Handles ActSearchLimits.Click
        ' ----- Toggle the display of the media type and location fields.
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then
            ' ----- Hide the two fields.
            LabelSearchMediaType.Visible = False
            SearchMediaType.Visible = False
            LabelSearchLocation.Visible = False
            SearchLocation.Visible = False
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                SearchMediaType.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                SearchMediaType.Top)
            ActSearch.Location = New Point(ActSearch.Left, SearchMediaType.Top)
            ActSearchLimits.Text = "Mor&e >>"
        Else
            ' ----- Show the two fields.
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                LabelMoreLimitsTop.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                LabelMoreLimitsTop.Top)
            ActSearch.Location = New Point(ActSearch.Left, LabelMoreLimitsTop.Top)
            LabelSearchMediaType.Visible = True
            SearchMediaType.Visible = True
            LabelSearchLocation.Visible = True
            SearchLocation.Visible = True
            ActSearchLimits.Text = "<< L&ess"
        End If
    End Sub

    Private Sub CheckInBarcode_Enter(sender As Object, e As EventArgs) Handles CheckInBarcode.Enter
        ' ----- Highlight the entire text.
        CheckInBarcode.SelectAll()
    End Sub

    Private Sub CheckOutBarcode_Enter(sender As Object, e As EventArgs) Handles CheckOutBarcode.Enter
        ' ----- Highlight the entire text.
        CheckOutBarcode.SelectAll()
    End Sub

    Private Sub MainForm_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        ' ----- The keys F2 through F9 access the different sections of the form.
        Select Case (e.KeyCode)
            Case Keys.F2
                TaskLibraryItem()
                e.Handled = True
            Case Keys.F3
                TaskPatronRecord()
                e.Handled = True
            Case Keys.F4
                ' ----- Allow form to handle Alt+F4.
                If (e.Alt = True) Then
                    Me.Close()
                Else
                    TaskHelp()
                End If
                e.Handled = True
            Case Keys.F5
                TaskCheckOut()
                e.Handled = True
            Case Keys.F6
                TaskCheckIn()
                e.Handled = True
            Case Keys.F7
                TaskAdmin()
                e.Handled = True
            Case Keys.F8
                TaskProcess()
                e.Handled = True
            Case Keys.F9
                TaskReports()
                e.Handled = True
            Case Keys.F12
                ' ----- Prompt the user for patron or administrative mode.
                ShowLoginForm()
                e.Handled = True
        End Select
    End Sub

    Private Sub AdminLinkBarcodeLabel_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkBarcodeLabel.LinkClicked
        ' ----- Let the user edit the list of barcode labels.
        If (SecurityProfile(LibrarySecurity.ManageBarcodeTemplates) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New BarcodeLabel)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkBarcodePage_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkBarcodePage.LinkClicked
        ' ----- Let the user edit the list of barcode pages.
        If (SecurityProfile(LibrarySecurity.ManageBarcodeTemplates) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New BarcodePage)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkGroups_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkGroups.LinkClicked
        ' ----- Let the user edit the list of security groups.
        If (SecurityProfile(LibrarySecurity.ManageGroups) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New GroupName)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkUsers_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkUsers.LinkClicked
        ' ----- Let the user edit the list of administrative users.
        If (SecurityProfile(LibrarySecurity.ManageUsers) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New UserName)
        ListEditRecords = Nothing
    End Sub

    Private Sub ActLogin_Click(sender As Object, e As EventArgs) Handles ActLogin.Click
        ' ----- Prompt the user for patron or administrative mode.
        ShowLoginForm()
    End Sub

    Private Sub ShowLoginForm()
        ' ----- Prompt the user for patron or administrative mode.
        Dim userChoice As DialogResult

        ' ----- Finish the in-process check-out if needed.
        If (ActiveCheckOutPatron <> -1&) Then ActFinishCheckOut.PerformClick()

        ' ----- Prompt the user.
        userChoice = ChangeUser.ShowDialog()
        ChangeUser = Nothing
        If (userChoice = DialogResult.OK) Then UpdateDisplayForUser()
    End Sub

    Private Sub UpdateDisplayForUser()
        ' ----- Update the display based on the user settings.
        Dim sqlText As String
        Dim sqlRun As DataCommand

        If (LoggedInUserID = -1&) Then
            ' ----- Set up the display for patron mode.
            ActiveMode.Text = "Welcome Library Patron"

            ' ----- See if patrons can check out items by themselves.
            Dim userCanCheckOut As Boolean =
                CBool(Val(GetSystemValue("PatronCheckOut")))

            LabelTasks.Visible = userCanCheckOut
            LineTasks.Visible = userCanCheckOut
            PicCheckOut.Visible = userCanCheckOut
            ActCheckOut.Visible = userCanCheckOut
            PicCheckIn.Visible = False
            ActCheckIn.Visible = False
            PicAdmin.Visible = False
            ActAdmin.Visible = False
            PicProcess.Visible = False
            ActProcess.Visible = False
            PicReports.Visible = False
            ActReports.Visible = False

            ' ----- Show or hide the Login button per the settings.
            ActLogin.Visible = Not My.Settings.HideLogin

            ' ----- Lookup items by default.
            TaskLibraryItem()
        Else
            ' ----- Set up the display for administrative mode.
            sqlText = "SELECT FullName FROM UserName WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", LoggedInUserID)
            Try
                ActiveMode.Text = "Administrative User: " & DBGetText(ExecuteSQLReturn(sqlRun))
            Catch ex As Exception
                GeneralError("MainForm.UpdateDisplayForUser", ex)
                ActiveMode.Text = "Administrative User: Unknown"
            End Try

            LabelTasks.Visible = True
            LineTasks.Visible = True
            PicCheckOut.Visible = True
            ActCheckOut.Visible = True
            PicCheckIn.Visible = True
            ActCheckIn.Visible = True
            PicAdmin.Visible = True
            ActAdmin.Visible = True
            PicProcess.Visible = True
            ActProcess.Visible = True
            PicReports.Visible = True
            ActReports.Visible = True
            ActLogin.Visible = True
        End If
    End Sub

    Private Sub AdminLinkItems_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkItems.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageItems) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of items.
        ListEditRecords.ManageRecords(New NamedItem)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthors_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthors.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthors) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of authors.
        ListEditRecords.ManageRecords(New Author)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthorTypes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthorTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthorTypes) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of author types.
        ListEditRecords.ManageRecords(New CodeAuthorType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPublishers_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPublishers.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePublishers) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of publishers.
        ListEditRecords.ManageRecords(New Publisher)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkSeries_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkSeries.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageSeries) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of series.
        ListEditRecords.ManageRecords(New CodeSeries)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkMediaTypes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkMediaTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageMediaTypes) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of media types.
        ListEditRecords.ManageRecords(New CodeMediaType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkStatusCodes_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkStatusCodes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageCopyStatus) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of copy status codes.
        ListEditRecords.ManageRecords(New CodeCopyStatus)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkLocations_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkLocations.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageLocations) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of locations.
        ListEditRecords.ManageRecords(New CodeLocation)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkHolidays_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkHolidays.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageHolidays) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of holidays.
        ListEditRecords.ManageRecords(New Holiday)
        ListEditRecords = Nothing

        ' ----- Reload the holidays if they changed.
        RefreshHolidays()
    End Sub

    Private Sub AdminLinkPatrons_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPatrons.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatrons) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of patrons.
        ListEditRecords.ManageRecords(New Patron)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPatronGroups_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkPatronGroups.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatronGroups) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Let the user edit the list of patron groups.
        ListEditRecords.ManageRecords(New CodePatronGroup)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkValues_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles AdminLinkValues.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageValues) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Access the maintenance portion of the program.
        Maintenance.ShowDialog()
    End Sub

    Private Sub ActDoReports_Click(sender As Object, e As EventArgs) Handles ActDoReports.Click
        ' ----- Show the reports form.
        ReportSelect.ShowDialog()
    End Sub

    Private Sub SearchType_SelectedIndexChanged(sender As Object, e As EventArgs) Handles SearchType.SelectedIndexChanged
        ' ----- Update the search hints.
        Select Case CLng(DirectCast(SearchType.SelectedItem, ListItemData))
            Case LookupMethods.ByTitle
                LabelSearchHintsData.Text = "Enter a title or partial title in the " &
                    "Search Text field. You may include the asterisk character ( * ) " &
                    "as a wildcard character."
            Case LookupMethods.ByAuthor
                LabelSearchHintsData.Text = "Enter an author name or partial author " &
                    "name in the Search Text field. You may include the asterisk " &
                    "character ( * ) as a wildcard character. Enter the name in " &
                    "last name, first name format, separated by a comma. You may omit " &
                    "the last name or first name if needed."
            Case LookupMethods.BySubject
                LabelSearchHintsData.Text = "Enter a subject or partial subject in the " &
                    "Search Text field. You may include the asterisk character ( * ) " &
                    "as a wildcard character."
            Case LookupMethods.ByKeywordAny
                LabelSearchHintsData.Text = "Enter one or more keywords in the " &
                    "Search Text field, separated by commas. Note that wildcard " &
                    "characters are not permitted in keyword searches. Items that " &
                    "match any one of the keywords will be returned."
            Case LookupMethods.ByKeywordAll
                LabelSearchHintsData.Text = "Enter one or more keywords in the " &
                    "Search Text field, separated by commas. Note that wildcard " &
                    "characters are not permitted in keyword searches. Only items " &
                    "that match all of the keywords will be returned."
            Case LookupMethods.ByPublisher
                LabelSearchHintsData.Text = "Enter a publisher name or partial " &
                    "publisher name in the Search Text field. You may include " &
                    "the asterisk character ( * ) as a wildcard character."
            Case LookupMethods.BySeries
                LabelSearchHintsData.Text = "Enter a series name or partial " &
                    "series name in the Search Text field. You may include " &
                    "the asterisk character ( * ) as a wildcard character."
            Case LookupMethods.ByBarcode
                LabelSearchHintsData.Text = "Enter a numeric barcode for a library " &
                    "item in the Search Text field. Note that wildcard characters " &
                    "are not allowed in barcode searches."
            Case LookupMethods.ByDatabaseID
                LabelSearchHintsData.Text = "Enter a numeric database ID for a library " &
                    "item in the Search Text field. Note that wildcard characters " &
                    "are not allowed in database ID searches."
        End Select
    End Sub

    Private Sub ActSearchClear_Click(sender As Object, e As EventArgs) Handles ActSearchClear.Click
        ' ----- Clear the current search criteria.
        SearchType.SelectedIndex = SearchType.Items.IndexOf(CLng(LookupMethods.ByTitle))
        SearchText.Text = ""
        SearchMediaType.SelectedIndex = SearchMediaType.Items.IndexOf(-1&)
        SearchLocation.SelectedIndex = SearchLocation.Items.IndexOf(-1&)
    End Sub

    Private Sub ActSearch_Click(sender As Object, e As EventArgs) Handles ActSearch.Click
        ' ----- The user wants to lookup some items.
        Dim mediaLimit As Long
        Dim locationLimit As Long
        Dim searchMethod As Long

        ' ----- Make sure the user supplied valid search criteria.
        searchMethod = CLng(DirectCast(SearchType.SelectedItem, ListItemData))
        Select Case searchMethod
            Case LookupMethods.ByTitle, LookupMethods.BySubject,
                    LookupMethods.ByPublisher, LookupMethods.BySeries
                ' ----- A search text is required.
                If (SearchText.Text.Trim().Length = 0) Then
                    MessageBox.Show("Please supply a search text.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByAuthor
                ' ----- A search text with a maximum of one comma is required.
                If (CountSubStr(SearchText.Text, ",") >= 2) Or
                        (SearchText.Text.Trim().Length = 0) Then
                    MessageBox.Show("Please supply a search text with a maximum of one comma.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If

                ' ----- Make sure at least one name component is supplied.
                If (SearchText.Text.GetSubStr(",", 1).Trim().Length = 0) And
                        (SearchText.Text.GetSubStr(",", 2).Trim().Length = 0) Then
                    MessageBox.Show("Please supply at least one name component.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByKeywordAny, LookupMethods.ByKeywordAll
                ' ----- A search text is required.
                If (SearchText.Text.Trim().Length = 0) Then
                    MessageBox.Show("Please supply a search text.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If

                ' ----- Make sure that no wildcards are included.
                If (SearchText.Text.Contains("*") = True) Then
                    MessageBox.Show(
                        "Wildcard characters (*) are not permitted in keyword searches.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByBarcode, LookupMethods.ByDatabaseID
                ' ----- A numeric search text is required.
                If (DigitsOnly(SearchText.Text) <> SearchText.Text.Trim()) Or
                        (SearchText.Text.Trim().Length = 0) Then
                    MessageBox.Show("Please supply a numeric search text.",
                        ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    SearchText.Focus()
                    Return
                End If
        End Select

        ' ----- Get the extended criteria if needed.
        mediaLimit = -1&
        locationLimit = -1&
        If (SearchMediaType.Visible = True) Then
            mediaLimit = CLng(DirectCast(SearchMediaType.SelectedItem, ListItemData))
            locationLimit = CLng(DirectCast(SearchLocation.SelectedItem, ListItemData))
        End If

        ' ----- Initiate the search.
        Call (New ItemLookup).InitiateSearch(
            CType(searchMethod, LookupMethods),
            SearchText.Text.Trim(), mediaLimit, locationLimit)
    End Sub

    Private Sub ActAccessPatron_Click(sender As Object, e As EventArgs) Handles ActAccessPatron.Click
        ' ----- Look up the record of an active patron.
        Dim patronID As Long

        ' ----- Get the ID of the patron.
        patronID = (New PatronAccess).SelectPatron()
        If (patronID = -1&) Then Return

        ' ----- Show the patron record.
        Call (New PatronRecord).ViewPatronRecord(patronID, True)
    End Sub

    Private Sub ActReportsBarcode_Click(sender As Object, e As EventArgs) Handles ActReportsBarcode.Click
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageBarcodeTemplates) = False) Then
            MessageBox.Show(NotAuthorizedMessage,
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ----- Show the barcode label printing form.
        Call (New BarcodePrint).ShowDialog()
    End Sub

    Private Sub ActCheckOutPatron_Click(sender As Object, e As EventArgs) Handles ActCheckOutPatron.Click
        ' ----- Select a different patron for check-out purposes.
        Dim patronID As Long
        Dim patronName As String
        Dim sqlText As String
        Dim sqlRun As DataCommand
        Dim finesDue As Decimal

        ' ----- Finish previous patron if needed.
        If (ActiveCheckOutPatron <> -1&) Then ActFinishCheckOut.PerformClick()

        ' ----- Get the ID of the patron.
        patronID = (New PatronAccess).SelectPatron()
        If (patronID = -1&) Then Return

        ' ----- Get the patron name.
        sqlText = "SELECT FirstName + ' ' + LastName FROM Patron " &
            "WHERE ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", patronID)
        Try
            patronName = DBGetText(ExecuteSQLReturn(sqlRun))
        Catch ex As Exception
            GeneralError("MainForm.ActCheckOutPatron_Click.Name", ex)
            patronName = "Unknown"
        End Try

        ' ----- Is this patron active?
        sqlText = "SELECT Active FROM Patron WHERE ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", patronID)
        Try
            If (DBGetBool(ExecuteSQLReturn(sqlRun)) = False) Then
                MessageBox.Show("Patron '" & patronName & "' is marked as inactive.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If
        Catch ex As Exception
            GeneralError("MainForm.ActCheckOutPatron_Click.Active", ex)
            Return
        End Try

        ' ----- OK to start using this patron.
        ActiveCheckOutPatron = patronID
        CheckOutPatronName.Text = patronName
        Me.Cursor = Cursors.WaitCursor

        ' ----- Show the patron if there are any fines due.
        finesDue = CalculatePatronFines(patronID)
        If (finesDue > 0@) Then
            MessageBox.Show("Patron: " & CheckOutPatronName.Text & vbCrLf &
                "Fines Due: " & finesDue.ToString("C"),
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

        ' ----- Show the other fields.
        LabelBarcode.Visible = True
        CheckOutBarcode.Text = ""
        CheckOutBarcode.Visible = True
        ActDoCheckOut.Visible = True
        LabelCheckedOutItems.Visible = True
        CheckedOutItems.Items.Clear()
        CheckedOutItems.Visible = True
        TotalCheckedOut.Text = "      0 items checked out."
        TotalCheckedOut.ImageIndex = StatusImageGood
        TotalCheckedOut.Visible = True
        ActFinishCheckOut.Visible = True
        Me.AcceptButton = ActDoCheckOut
        Me.Cursor = Cursors.Default
        CheckOutBarcode.Focus()
    End Sub

    Private Sub ActDoCheckOut_Click(sender As Object, e As EventArgs) Handles ActDoCheckOut.Click
        ' ----- The user wants to check out an item.
        Dim sqlText As String
        Dim sqlRun As DataCommand
        Dim dbInfo As DataTable
        Dim oneRow As DataRow
        Dim copyID As Long
        Dim namedID As Long
        Dim checkoutDays As Integer
        Dim untilDate As Date
        Dim itemDetail As CheckedOutItem
        Dim somePatron As Long
        Dim transInfo As LibraryTransaction = Nothing

        ' ----- A barcode or title is required.
        If (CheckOutBarcode.Text.Trim().Length = 0) Then
            MessageBox.Show("Please supply a valid barcode or item title for check out.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ------ The user supplied either a barcode or a copy. We need to
        '        get the ID of the copy instead.
        If (IsNumeric(CheckOutBarcode.Text.Trim())) Then
            ' ----- Probably a barcode supplied. Get the related ID.
            sqlText = "SELECT ID FROM ItemCopy WHERE Barcode = @TestBarcode"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddText("TestBarcode", CheckOutBarcode.Text.Trim())
            Try
                copyID = DBGetLong(ExecuteSQLReturn(sqlRun), -1&)
            Catch ex As Exception
                GeneralError("MainForm.ActDoCheckOut.Copy", ex)
                copyID = -1&
            End Try
            If (copyID = -1&) Then
                ' ----- Invalid barcode.
                MessageBox.Show("Barcode not found.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                CheckOutBarcode.Focus()
                CheckOutBarcode.SelectAll()
                Return
            End If
        Else
            ' ----- Lookup by title.
            copyID = (New CheckLookup).CheckItemByTitle(False,
                CheckOutBarcode.Text.Trim())
            If (copyID = -1&) Then Return
        End If
        Me.Cursor = Cursors.WaitCursor

        ' ----- Get the named ID for this copy ID.
        sqlText = "SELECT ItemID FROM ItemCopy WHERE ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            namedID = DBGetLong(ExecuteSQLReturn(sqlRun))
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.Named", ex)
            Return
        End Try

        ' ----- Build a record that will store the item details.
        itemDetail = New CheckedOutItem

        ' ----- Get some general information about the item.
        sqlText = "SELECT NI.Title, IC.CopyNumber, IC.Barcode " &
            "FROM ItemCopy AS IC INNER JOIN NamedItem AS NI ON IC.ItemID = NI.ID " &
            "WHERE IC.ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.Info", ex)
            Return
        End Try
        oneRow = dbInfo.Rows(0)
        itemDetail.Barcode = DBGetText(oneRow!Barcode)
        itemDetail.ItemTitle = DBGetText(oneRow!Title)
        itemDetail.CopyNumber = DBGetInteger(oneRow!CopyNumber)
        dbInfo.Dispose()

        ' ----- Make sure this copy is available for circulation.
        sqlText = "SELECT Available, Reference FROM ItemCopy WHERE ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.Circ", ex)
            Return
        End Try
        oneRow = dbInfo.Rows(0)
        If (DBGetBool(oneRow!Available) = False) Or (DBGetBool(oneRow!Reference) = True) Then
            Me.Cursor = Cursors.Default
            dbInfo.Dispose()
            dbInfo = Nothing
            MessageBox.Show("You cannot check out this copy of '" & itemDetail.ItemTitle &
                "' because it is not available for circulation.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            CheckOutBarcode.Focus()
            CheckOutBarcode.SelectAll()
            Return
        End If
        dbInfo.Dispose()

        ' ----- Make sure this title is not already checked out.
        sqlText = "SELECT Patron FROM PatronCopy " &
            "WHERE ItemCopy = @RecordID AND Returned = 0"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            somePatron = DBGetLong(ExecuteSQLReturn(sqlRun), -1&)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.Out", ex)
            Return
        End Try
        If (somePatron <> -1&) Then
            Me.Cursor = Cursors.Default
            If (somePatron = ActiveCheckOutPatron) Then
                MessageBox.Show("You cannot renew an item through the check out " &
                    "features of this system. Use the renewal features through " &
                    "the Patron Record portion of the system. Please see the " &
                    "library staff for assistance.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Else
                MessageBox.Show("You cannot check out this copy of '" &
                    itemDetail.ItemTitle & "' because it is currently checked " &
                    "out to another patron. Please see the " &
                    "library staff for assistance.",
                    ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
            CheckOutBarcode.Focus()
            CheckOutBarcode.SelectAll()
            Return
        End If

        ' ----- Get the number of days this item can be checked out.
        sqlText = "SELECT CMT.CheckoutDays FROM NamedItem AS NI INNER JOIN " &
            "CodeMediaType AS CMT ON NI.MediaType = CMT.ID WHERE NI.ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", namedID)
        Try
            checkoutDays = DBGetInteger(ExecuteSQLReturn(sqlRun))
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.Days", ex)
            Return
        End Try
        If (checkoutDays = 0) Then
            Me.Cursor = Cursors.Default
            MessageBox.Show("You cannot check out this copy of '" &
                itemDetail.ItemTitle & "' because it has a check out limit " &
                "of zero days. Please see the library staff for assistance.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            CheckOutBarcode.Focus()
            CheckOutBarcode.SelectAll()
            Return
        End If

        ' ----- Don't allow the due date to be on a holiday.
        untilDate = Today.AddDays(checkoutDays)
        Do While (IsHolidayDate(untilDate) = True)
            untilDate = untilDate.AddDays(1)
        Loop
        itemDetail.DueDate = untilDate

        Try
            ' ----- Perform the check-out in a transaction.
            transInfo = TransactionBegin()

            ' ----- Update patron copy record.
            sqlText = "INSERT INTO PatronCopy (Patron, ItemCopy, CheckOut, Renewal, " &
                "DueDate, Returned, Missing, Fine, Paid) VALUES (@NewPatron, @NewCopy, " &
                "@NewDate, 0, @NewDue, 0, 0, 0, 0)"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("NewPatron", ActiveCheckOutPatron)
            sqlRun.AddLong("NewCopy", copyID)
            sqlRun.AddDate("NewDate", Today)
            sqlRun.AddDate("NewDue", untilDate)
            ExecuteSQL(sqlRun, transInfo)

            ' ----- Update the patron record.
            sqlText = "UPDATE Patron SET LastActivity = GETDATE() " &
                "WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", ActiveCheckOutPatron)
            ExecuteSQL(sqlRun, transInfo)

            TransactionCommit(transInfo)
        Catch ex As Exception
            TransactionRollback(transInfo)
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckOut.CheckOut", ex)
            Return
        End Try

        ' ----- Display results.
        CheckedOutItems.Items.Add(itemDetail)
        If (CheckedOutItems.Items.Count = 1) Then
            TotalCheckedOut.Text = "      1 item checked out."
        Else
            TotalCheckedOut.Text = "      " & CheckedOutItems.Items.Count &
                " item checked out."
        End If
        Me.Cursor = Cursors.Default

        ' ----- Finished.
        CheckOutBarcode.Text = ""
        CheckOutBarcode.Focus()
    End Sub

    Private Sub ActFinishCheckOut_Click(sender As Object, e As EventArgs) Handles ActFinishCheckOut.Click
        ' ----- Print a check-out ticket if possible.
        PrintCheckoutTicket(ActiveCheckOutPatron, CheckedOutItems)

        ' ----- Clear the active check-out patron.
        Me.AcceptButton = ActCheckOutPatron
        ActiveCheckOutPatron = -1&
        CheckOutPatronName.Text = "No active patron."
        LabelBarcode.Visible = False
        CheckOutBarcode.Text = ""
        CheckOutBarcode.Visible = False
        ActDoCheckOut.Visible = False
        LabelCheckedOutItems.Visible = False
        CheckedOutItems.Items.Clear()
        CheckedOutItems.Visible = False
        TotalCheckedOut.Text = "      0 items checked out."
        TotalCheckedOut.ImageIndex = StatusImageGood
        TotalCheckedOut.Visible = False
        ActFinishCheckOut.Visible = False
    End Sub

    Private Sub CheckedOutItems_DrawItem(sender As Object, e As DrawItemEventArgs) Handles CheckedOutItems.DrawItem
        ' ----- Draw the matching items on two lines.
        Dim useBrush As Brush
        Dim dateText As String
        Dim titleText As String
        Dim itemDetail As CheckedOutItem
        Dim ellipsesText As StringFormat

        ' ----- Ignore undrawable items.
        If (e.Index = -1) Then Return

        ' ----- Draw the background of the item.
        If (CBool(CInt(e.State) And CInt(DrawItemState.Selected))) _
            Then useBrush = SystemBrushes.HighlightText _
            Else useBrush = SystemBrushes.WindowText
        e.DrawBackground()

        ' ----- Extract the detail from the list.
        itemDetail = DirectCast(CheckedOutItems.Items(e.Index), CheckedOutItem)

        ' ----- Format the display fields.
        dateText = itemDetail.DueDate.ToString("M/d/yyyy")
        titleText = itemDetail.Barcode
        If (titleText.Length <> 0) Then titleText &= " - "
        titleText &= itemDetail.ItemTitle & " (Copy " & itemDetail.CopyNumber & ")"
        ellipsesText = New StringFormat
        ellipsesText.Trimming = StringTrimming.EllipsisCharacter

        ' ----- Draw the text of the item.
        e.Graphics.DrawString(dateText, e.Font, useBrush,
            New Rectangle(0, e.Bounds.Top, LabelCheckedOutCol2.Left -
            CheckedOutItems.Left - 5, e.Font.Height), ellipsesText)
        e.Graphics.DrawString(titleText, e.Font, useBrush, LabelCheckedOutCol2.Left -
            CheckedOutItems.Left, e.Bounds.Top)

        ' ----- If the ListBox has focus, draw a focus rectangle.
        e.DrawFocusRectangle()
    End Sub

    Private Sub CheckInDate_ValueChanged(sender As Object, e As EventArgs) Handles CheckInDate.ValueChanged
        ' ----- Adjust the day in the display.
        Select Case CInt((Today - CheckInDate.Value).TotalDays)
            Case 0    ' ----- Today
                CheckInDay.Text = "Today"
                CheckInDay.BackColor = SystemColors.Control
                CheckInDay.ForeColor = SystemColors.ControlText
            Case 1    ' ----- Yesterday
                CheckInDay.Text = "Yesterday"
                CheckInDay.BackColor = Color.Red
                CheckInDay.ForeColor = Color.White
            Case Else ' ----- X days ago
                CheckInDay.Text = CInt((Today - CheckInDate.Value).TotalDays).ToString() & " days ago"
                CheckInDay.BackColor = Color.Red
                CheckInDay.ForeColor = Color.White
        End Select
    End Sub

    Private Sub ActDoCheckIn_Click(sender As Object, e As EventArgs) Handles ActDoCheckIn.Click
        ' ----- The user wants to check in an item.
        Dim sqlText As String
        Dim sqlRun As DataCommand
        Dim dbInfo As DataTable
        Dim oneRow As DataRow
        Dim copyID As Long
        Dim patronCopyID As Long
        Dim copyMissing As Boolean
        Dim daysLate As Integer
        Dim fineOwed As Decimal
        Dim itemInfo As String
        Dim patronID As Long
        Dim transInfo As LibraryTransaction = Nothing

        ' ----- A barcode or title is required.
        If (CheckInBarcode.Text.Trim().Length = 0) Then
            MessageBox.Show("Please supply a valid barcode or item title for check in.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If

        ' ------ The user supplied either a barcode or a copy. We need to
        '        get the ID of the copy instead.
        If (IsNumeric(CheckInBarcode.Text.Trim())) Then
            ' ----- Probably a barcode supplied. Get the related ID.
            sqlText = "SELECT ID FROM ItemCopy WHERE Barcode = @TestBarcode"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddText("TestBarcode", CheckInBarcode.Text.Trim())
            Try
                copyID = DBGetLong(ExecuteSQLReturn(sqlRun), -1&)
            Catch ex As Exception
                GeneralError("MainForm.ActDoCheckIn.Copy", ex)
                copyID = -1&
            End Try
            If (copyID = -1&) Then
                ' ----- Invalid barcode.
                LabelCheckedIn.Text = "      Barcode not found."
                LabelCheckedIn.ImageIndex = StatusImageBad
                LabelCheckedIn.Visible = True
                CheckedInDetail.Visible = False
                CheckInBarcode.Focus()
                CheckInBarcode.SelectAll()
                Return
            End If
        Else
            ' ----- Lookup by title.
            copyID = (New CheckLookup).CheckItemByTitle(True,
                CheckInBarcode.Text.Trim())
            If (copyID = -1&) Then Return
        End If
        Me.Cursor = Cursors.WaitCursor

        ' ----- Get some general information about the book.
        sqlText = "SELECT NI.Title, NI.Subtitle, IC.CopyNumber, IC.Barcode " &
            "FROM ItemCopy AS IC INNER JOIN NamedItem AS NI ON IC.ItemID = NI.ID " &
            "WHERE IC.ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckIn.Info", ex)
            Return
        End Try
        oneRow = dbInfo.Rows(0)
        itemInfo = DBGetText(oneRow!Title)
        If (IsDBNull(oneRow!Subtitle) = False) Then _
            itemInfo &= ": " & DBGetText(oneRow!Subtitle)
        itemInfo &= vbCrLf & vbCrLf & "Copy: " & DBGetInteger(oneRow!CopyNumber).ToString()
        If (IsDBNull(oneRow!Barcode) = False) Then _
            itemInfo &= vbCrLf & "Barcode: " & DBGetText(oneRow!Barcode)
        dbInfo.Dispose()

        ' ----- Make sure this title is checked out.
        sqlText = "SELECT ID, Patron, Missing FROM PatronCopy " &
            "WHERE ItemCopy = @RecordID AND Returned = 0"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", copyID)
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckIn.Verify", ex)
            Return
        End Try
        If (dbInfo.Rows.Count = 0) Then
            Me.Cursor = Cursors.Default
            dbInfo.Dispose()
            dbInfo = Nothing
            LabelCheckedIn.Text = "      Indicated item was not checked out."
            LabelCheckedIn.ImageIndex = StatusImageBad
            LabelCheckedIn.Visible = True
            CheckedInDetail.Text = itemInfo
            CheckedInDetail.Visible = True
            CheckInBarcode.Focus()
            CheckInBarcode.SelectAll()
            Return
        End If
        oneRow = dbInfo.Rows(0)
        patronCopyID = DBGetLong(oneRow!ID)
        patronID = DBGetLong(oneRow!Patron)
        copyMissing = DBGetBool(oneRow!Missing)
        dbInfo.Dispose()

        ' ----- Handle missing items. Although it is not done here, a possible
        '       enhancement would be to recognize any fine charaged to the
        '       patron specifically for the missing book, and prompt a refund.
        If (copyMissing) Then
            ' ----- No longer missing.
            sqlText = "UPDATE PatronCopy SET Missing = 0 WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", patronCopyID)
            Try
                ExecuteSQL(sqlRun)
            Catch ex As Exception
                Me.Cursor = Cursors.Default
                GeneralError("MainForm.ActDoCheckIn.Miss1", ex)
                Return
            End Try

            sqlText = "UPDATE ItemCopy SET Missing = 0 WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", copyID)
            Try
                ExecuteSQL(sqlRun)
            Catch ex As Exception
                Me.Cursor = Cursors.Default
                GeneralError("MainForm.ActDoCheckIn.Miss2", ex)
                Return
            End Try
        End If

        ' ----- Handle overdue items.
        daysLate = 0
        fineOwed = 0@
        sqlText = "SELECT DueDate, Fine, Paid FROM PatronCopy " &
            "WHERE ID = @RecordID"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddLong("RecordID", patronCopyID)
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckIn.Overdue", ex)
            Return
        End Try
        oneRow = dbInfo.Rows(0)
        If (DBGetDate(oneRow!DueDate) < Today) Then
            daysLate = CInt((Today - DBGetDate(oneRow!DueDate)).TotalDays)
        End If
        If (IsDBNull(oneRow!Fine) = False) Then fineOwed = DBGetDecimal(oneRow!Fine)
        If (IsDBNull(oneRow!Paid) = False) Then fineOwed -= DBGetDecimal(oneRow!Paid)
        If (fineOwed < 0@) Then fineOwed = 0@
        dbInfo.Dispose()

        Try
            ' ----- Do the check-in in a transaction.
            transInfo = TransactionBegin()

            ' ----- Update patron copy record.
            sqlText = "UPDATE PatronCopy SET CheckIn = @NewDate, " &
                "Returned = 1 WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddDate("NewDate", CheckInDate.Value)
            sqlRun.AddLong("RecordID", patronCopyID)
            ExecuteSQL(sqlRun, transInfo)

            ' ----- Update the patron record.
            sqlText = "UPDATE Patron SET LastActivity = GETDATE() " &
                "WHERE ID = @RecordID"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddLong("RecordID", patronID)
            ExecuteSQL(sqlRun, transInfo)

            TransactionCommit(transInfo)
        Catch ex As Exception
            TransactionRollback(transInfo)
            Me.Cursor = Cursors.Default
            GeneralError("MainForm.ActDoCheckIn.CheckIn", ex)
            Return
        End Try

        ' ----- Display results.
        LabelCheckedIn.Text = "      The following item was checked in successfully."
        LabelCheckedIn.ImageIndex = StatusImageGood
        LabelCheckedIn.Visible = True
        If (daysLate > 0) Or (fineOwed > 0@) Then itemInfo &= vbCrLf
        If (daysLate > 0) Then itemInfo &= vbCrLf & "Days Late: " & daysLate.ToString()
        If (fineOwed > 0@) Then itemInfo &= vbCrLf & "Fine Owed: " &
            fineOwed.ToString("C")
        CheckedInDetail.Text = itemInfo
        CheckedInDetail.Visible = True
        Me.Cursor = Cursors.Default

        ' ----- Finished.
        CheckInBarcode.Text = ""
        CheckInBarcode.Focus()
        dbInfo = Nothing
    End Sub
End Class
