﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class Form1
    Private WhichPage As Integer

    Private Sub ActPrint_Click(sender As Object, e As EventArgs) Handles ActPrint.Click
        ' ----- Prompt the user for printer settings, and start printing.
        UserPrinter.Document = CountingDoc
        UserPrinter.AllowSomePages = True
        If (UserPrinter.ShowDialog() = DialogResult.OK) Then CountingDoc.Print()
    End Sub

    Private Sub CountingDoc_BeginPrint(sender As Object, e As Printing.PrintEventArgs) Handles CountingDoc.BeginPrint
        ' ----- Start the counting over.
        WhichPage = CountingDoc.PrinterSettings.FromPage
    End Sub

    Private Sub CountingDoc_PrintPage(sender As Object, e As Printing.PrintPageEventArgs) Handles CountingDoc.PrintPage
        ' ----- Print a single page.
        Dim hugeFont As Font
        Dim centeredText As StringFormat

        ' ----- Let's go overboard on the font: 256 points!
        hugeFont = New Font("Arial", 256)

        ' ----- Center the text on the page.
        centeredText = New StringFormat()
        centeredText.Alignment = StringAlignment.Center
        centeredText.LineAlignment = StringAlignment.Center

        ' ----- Print the number.
        e.Graphics.DrawString(WhichPage.ToString(), hugeFont,
            Brushes.Black, e.MarginBounds, centeredText)

        ' ----- Draw the page margins to make it clear where they are.
        e.Graphics.DrawRectangle(Pens.Blue, e.MarginBounds)

        ' ----- Limit the output to five pages.
        WhichPage += 1
        e.HasMorePages = (WhichPage <= CountingDoc.PrinterSettings.ToPage)
    End Sub

    Private Sub ActPreview_Click(sender As Object, e As EventArgs) Handles ActPreview.Click
        ' ----- Display a preview of the document.
        UserPreview.Document = CountingDoc
        CountingDoc.PrinterSettings.PrintRange = Printing.PrintRange.AllPages
        UserPreview.ShowDialog()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Default to five pages.
        CountingDoc.PrinterSettings.MinimumPage = 1
        CountingDoc.PrinterSettings.MaximumPage = 5
        CountingDoc.PrinterSettings.FromPage = 1
        CountingDoc.PrinterSettings.ToPage = 5
    End Sub
End Class
