﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class SubjectAdd
    Private ActiveID As Long

    Public Function AddRecord() As Long
        ' ----- Add a new subject.
        ActiveID = -1&
        Me.ShowDialog()
        If (Me.DialogResult = DialogResult.OK) Then _
            Return ActiveID Else Return -1&
    End Function

    Private Function SaveFormData() As Boolean
        ' ----- Save the record to the database.
        Dim sqlText As String
        Dim sqlRun As DataCommand
        Dim newID As Long
        Dim dbInfo As DataTable

        Me.Cursor = Cursors.WaitCursor

        ' ----- See if this subject already exists.
        sqlText = "SELECT ID FROM Subject WHERE FullName LIKE @TestName"
        sqlRun = New DataCommand(sqlText)
        sqlRun.AddText("TestName", RecordSubject.Text.Trim())
        Try
            dbInfo = CreateDataTable(sqlRun)
        Catch ex As Exception
            GeneralError("SubjectAdd.SaveFormData.Test", ex)
            Me.Cursor = Cursors.Default
            Return False
        End Try
        If (dbInfo.Rows.Count > 0) Then ActiveID = DBGetLong(dbInfo.Rows(0) !ID, -1&)
        dbInfo.Dispose()
        dbInfo = Nothing

        ' ----- Create a new record if needed.
        If (ActiveID = -1&) Then
            ' ----- Create a new entry.
            sqlText = "INSERT INTO Subject (FullName) OUTPUT INSERTED.ID " &
                "VALUES (@NewName)"
            sqlRun = New DataCommand(sqlText)
            sqlRun.AddText("NewName", RecordSubject.Text.Trim())
            Try
                newID = DBGetLong(ExecuteSQLReturn(sqlRun))
            Catch ex As Exception
                GeneralError("SubjectAdd.SaveFormData.Add", ex)
                Me.Cursor = Cursors.Default
                Return False
            End Try
            ActiveID = newID
        End If

        ' ----- Success.
        Me.Cursor = Cursors.Default
        Return True
    End Function

    Private Function ValidateFormData() As Boolean
        ' ----- Subject is a required field.
        If (RecordSubject.Text.Trim().Length = 0) Then
            MessageBox.Show("Please supply a subject.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            RecordSubject.Focus()
            Return False
        End If

        ' ----- Success.
        Return True
    End Function

    Private Sub RecordSubject_Enter(sender As Object, e As EventArgs) Handles RecordSubject.Enter
        ' ----- Highlight the entire text.
        RecordSubject.SelectAll()
    End Sub

    Private Sub ActOK_Click(sender As Object, e As EventArgs) Handles ActOK.Click
        ' ----- The user wants to save changes.
        If (ValidateFormData() = False) Then Return
        If (SaveFormData() = False) Then Return

        ' ----- Continue with AddRecord()
        Me.DialogResult = DialogResult.OK
    End Sub
End Class